// GLSL verze 1.0 a Shader model 4.0
#version 120
#extension GL_EXT_gpu_shader4 : enable

// Vstupni textury
uniform sampler2D Aoperand_front;
uniform sampler2D Aoperand_back;
uniform sampler2D Boperand_front;
uniform sampler2D Boperand_back;
uniform sampler2D Aoperand_front_n;
uniform sampler2D Aoperand_back_n;
uniform sampler2D Boperand_front_n;
uniform sampler2D Boperand_back_n;

// Jakou operaci budeme provadet?
uniform int method;

// Koordinaty textur z geometry shaderu
varying in vec2 v2_texCoord_gout;

// Main
void main()
{
	// Zisk veskerych dat pro dany pixel
	vec3 Aoperand_front_pos = texture2D(Aoperand_front, v2_texCoord_gout).xyz;
	vec3 Aoperand_back_pos = texture2D(Aoperand_back, v2_texCoord_gout).xyz;
	vec3 Boperand_front_pos = texture2D(Boperand_front, v2_texCoord_gout).xyz;
	vec3 Boperand_back_pos = texture2D(Boperand_back, v2_texCoord_gout).xyz;
	float Aoperand_front_d = length(Aoperand_front_pos);
	float Aoperand_back_d = length(Aoperand_back_pos);
	float Boperand_front_d = length(Boperand_front_pos);
	float Boperand_back_d = length(Boperand_back_pos);
	
	// Vystupni hodnoty jsou nulove
	vec3 booleanPos = vec3(0.0, 0.0, 0.0);
	vec3 booleanNorm = vec3(0.0, 0.0, 0.0);
	
	// Teleso B-A, prepis matematickeho vzorce
	if(method == 0)
	{
		booleanPos = Aoperand_front_pos;
		booleanNorm = texture2D(Aoperand_front_n, v2_texCoord_gout).xyz;
		if(Boperand_front_d < Aoperand_front_d && Boperand_back_d > Aoperand_front_d)
		{
			if(Boperand_back_d < Aoperand_back_d)
			{
				booleanPos = Boperand_back_pos;
				booleanNorm = texture2D(Boperand_back_n, v2_texCoord_gout).xyz;
			}
			else
			{
				booleanPos = vec3(0.0, 0.0, 0.0);
				booleanNorm = vec3(0.0, 0.0, 0.0);
			}
		}
	}
	// Teleso A-B prepis matematickeho vzorce
	else if(method == 1)
	{
		booleanPos = Boperand_front_pos;
		booleanNorm = texture2D(Boperand_front_n, v2_texCoord_gout).xyz;
		if(Aoperand_front_d < Boperand_front_d && Aoperand_back_d > Boperand_front_d)
		{
			if(Aoperand_back_d < Boperand_back_d)
			{
				booleanPos = Aoperand_back_pos;
				booleanNorm = texture2D(Aoperand_back_n, v2_texCoord_gout).xyz;
			}
			else
			{
				booleanPos = vec3(0.0, 0.0, 0.0);
				booleanNorm = vec3(0.0, 0.0, 0.0);
			}
		}
	}
	// Teleso A+B prepis matematickeho vzorce
	else if(method == 2)
	{
		if(Boperand_front_d < Aoperand_front_d && Boperand_front_d > 0.0 || Aoperand_front_d == 0.0)
		{
			booleanPos = Boperand_front_pos;
			booleanNorm = texture2D(Boperand_front_n, v2_texCoord_gout).xyz;
		}
		else
		{
			booleanPos = Aoperand_front_pos;
			booleanNorm = texture2D(Aoperand_front_n, v2_texCoord_gout).xyz;
		}
	}
	// Teleso pruniku A a B, prepis matematickeho vzorce
	else if(method == 3)
	{
		booleanPos = vec3(0.0, 0.0, 0.0);
		booleanNorm = vec3(0.0, 0.0, 0.0);
		
		if(Boperand_front_d < Aoperand_front_d)
		{
			if(Aoperand_front_d < Boperand_back_d)
			{
				booleanPos = Aoperand_front_pos;
				booleanNorm = texture2D(Aoperand_front_n, v2_texCoord_gout).xyz;
			}
		}
		else
		{
			if(Boperand_front_d < Aoperand_back_d)
			{
				booleanPos = Boperand_front_pos;
				booleanNorm = texture2D(Boperand_front_n, v2_texCoord_gout).xyz;
			}
		}
	}
	
	// Vystup pozic a normal do prvniho, resp. druheho bufferu MRT
	gl_FragData[0] = vec4(booleanPos, 1.0);
	gl_FragData[1] = vec4(booleanNorm, 1.0);
}