// GLSL verze 1.0 a Shader model 4.0
#version 120
#extension GL_EXT_gpu_shader4 : enable

// Vystup z vertex shaderu
varying out vec2 v2_texCoord_vout;
varying out vec3 lightPosMV_vout;

// Vstup z programu (svetlo a modelview inverse matice)
uniform vec3 lightPos;
uniform mat4 ModelViewMat;

// Main
void main()
{
	// Texturove koordinaty
	v2_texCoord_vout = gl_MultiTexCoord0.xy;
	// Svetlo prevedene tak, aby bylo relativni ke kamere
	lightPosMV_vout = vec3(ModelViewMat * vec4(lightPos, 1.0));

	// Transformace vertexu pomoci OpenGL modelview projekcni matice
	gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
}